/*
****************************************************************************
* Radar Ultrasuoni ver 1.0                                                 *
* con Arduino Uno (software ver. 1.0.1) e Processing (software ver. 2.0b7) *
* By Ermes ZANNONI                                                         *
* http://www.zannoni.to.it                                                 *
****************************************************************************
*/

import processing.serial.*;
Serial myPort;

float px, py, px_tgt, py_tgt;
float step = 2;
float range_array_number = (90/step)+1;
float[] range_array = new float[int(range_array_number)];
int range_angle_count = 0;
int direction_scanner = 1;
float range_misured;
String distanza = "";
PFont myFont;

void setup(){
  size(800, 510);
  background (127);
  
  myFont = createFont("verdana", 20);
  textFont(myFont);
  
  myPort = new Serial(this, "COM3", 9600);
  myPort.bufferUntil('\n');
  delay(2000);

}

void draw(){
  
  // TEMPO DI ATTESA
  delay(100);
  
  // COLORE SFONDO
  background (127);
  
  // MOVIMENTO DELLO SCANNER 
  if(range_angle_count*step==90)
    direction_scanner=-1;
  if(range_angle_count*step==0)
    direction_scanner=1;
  range_angle_count+=direction_scanner;
  
  // RETICOLATO
  fill(255);
  stroke(255, 204, 0);
  //arc(400, 500, 1000, 1000, -3*PI/4, -PI/4);
  arc(400, 500, 1000, 1000, radians(-135), radians(-45));
  arc(400, 500, 900, 900, radians(-135), radians(-45));
  arc(400, 500, 800, 800, radians(-135), radians(-45));  
  arc(400, 500, 700, 700, radians(-135), radians(-45));
  arc(400, 500, 600, 600, radians(-135), radians(-45));
  arc(400, 500, 500, 500, radians(-135), radians(-45));
  arc(400, 500, 400, 400, radians(-135), radians(-45));
  arc(400, 500, 300, 300, radians(-135), radians(-45));
  arc(400, 500, 200, 200, radians(-135), radians(-45));
  arc(400, 500, 100, 100, radians(-135), radians(-45));

  // POSIZIONE IN GRADI DELLO SCANNER
  text(range_angle_count*step, 430, 500);
  
  // VISUALIZZAZIONE TGT
  fill(0,0,255);
  stroke(0, 0, 255);
  for(int x=0; x<=range_array_number-1; x++) {
    px_tgt = 400 + cos(radians(x*step+225))*(range_array[x]*5);
    py_tgt = 500 + sin(radians(x*step+225))*(range_array[x]*5);
    rect(px_tgt-1, py_tgt, 3, 3);
  }
  
  // POSIZIONE DELLO SCANNER
  fill(255,0,0);
  stroke(255, 0, 0);
  ellipse(400, 500, 8, 8); 
    
  // RUOTARE BARRA SCANSIONE E RILEVATORE DISTANZA 
  myPort.write(range_angle_count);
  px = 400 + cos(radians(range_angle_count*step+225))*(500);
  py = 500 + sin(radians(range_angle_count*step+225))*(500);  
  stroke(255,0,0);
  line(400, 500, px, py);
  
  // TEMPO DI ATTESA
  delay(250);
  
  // LETTURA DISTANZA CON HC-SR04
  range_array[range_angle_count] = float(distanza); 

}

void serialEvent(Serial myPort) {
  distanza = myPort.readString();
}

